VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "AccelCol"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"Accel"
Attribute VB_Ext_KEY = "Member0" ,"Accel"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
''' Enhanced Menu v2.3

''' Owner-drawn menu control for all Windows editions.
''' Accelerator Table Class.

''' Copyright (C) 2000 Nathan Moschkin.
''' All Rights Reserved.

''' Free to copy and distribute, intact.  Give credit to me and anyone else
''' who may edit this code.

''' Please inquire before using any of this code or the DLL control commercially.
''' An OCX version of the menu with added features will be available soon.

''' E-Mail questions or comments to nmosch@tampabay.rr.com

Option Explicit

'local variable to hold collection
Private mCol As Collection

Public Sub MakeTable(OwnerMenu As Object)
    On Error Resume Next
    Dim x_e As EnhancedMenu, x_s As Submenu, x_i As MenuItem
        
    If OwnerMenu Is Nothing Then Exit Sub
        
    Set mCol = New Collection
    
    If TypeOf OwnerMenu Is EnhancedMenu Then
        Set x_e = OwnerMenu
        For Each x_i In x_e
            Set x_i.Accelerator.Tabl = Me
            x_i.Accelerator.Cmd = x_i.MenuId
            
            Me.Add x_i.Accelerator
            
            If x_i.Submenu.Count > 0 Then
                x_i.Submenu.Accelerators.MakeTable x_i.Submenu
            End If
            
        Next x_i
    Else
        Set x_s = OwnerMenu
        For Each x_i In x_s
            Set x_i.Accelerator.Tabl = Me
            x_i.Accelerator.Cmd = x_i.MenuId
            
            Me.Add x_i.Accelerator
            
            If x_i.Submenu.Count > 0 Then
                x_i.Submenu.Accelerators.MakeTable x_i.Submenu
            End If
            
        Next x_i
    End If
    
End Sub

Public Function Add(pAccel As Variant, Optional ByVal cSelector As String) As Accelerator
    On Error Resume Next
    
    Dim objNewMember As Accelerator
    Dim aStruct As ACCEL, aString As String
    
    If TypeName(pAccel) = "ACCEL" Then
        aStruct.Key = pAccel.Key
        aStruct.fVirt = pAccel.fVirt
        aStruct.Cmd = pAccel.Cmd
    ElseIf TypeName(pAccel) = "String" Then
        aString = pAccel
    ElseIf TypeName(pAccel) = "Accelerator" Then
        Set pAccel.Tabl = Me
        If cSelector <> "" Then
            pAccel.Selector = cSelector
        End If
        
        mCol.Add pAccel
        Set Add = pAccel
        Exit Function
    End If
        
    Set objNewMember = New Accelerator
    
    Set objNewMember.Tabl = Me
    
    objNewMember.Selector = cSelector
    objNewMember.fVirt = aStruct.fVirt
    objNewMember.Key = aStruct.Key
    objNewMember.Cmd = aStruct.Cmd
        
    If aString <> "" Then
        objNewMember.AccelWord = aString
    End If
        
    mCol.Add objNewMember
    
    Set Add = objNewMember
    Set objNewMember = Nothing

End Function

Public Property Get Item(varIndexKey As Variant) As Accelerator
    On Error Resume Next
        
    Set Item = mCol(varIndexKey)
    
End Property

Public Property Get Count() As Long
    Count = mCol.Count
End Property


Public Sub Remove(varIndexKey As Variant)

    mCol.Remove varIndexKey
End Sub


Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    'this property allows you to enumerate
    'this collection with the For...Each syntax
    Set NewEnum = mCol.[_NewEnum]
End Property


Private Sub Class_Initialize()
    'creates the collection when this class is created
    Set mCol = New Collection
End Sub


Private Sub Class_Terminate()
    'destroys collection when this class is terminated
    Set mCol = Nothing
End Sub

