VERSION 5.00
Begin VB.MDIForm MDIForm1 
   BackColor       =   &H8000000C&
   Caption         =   "MDI Client/Frame Subclassing Menu Example Form"
   ClientHeight    =   4890
   ClientLeft      =   3495
   ClientTop       =   4095
   ClientWidth     =   6870
   LinkTopic       =   "MDIForm1"
   NegotiateToolbars=   0   'False
End
Attribute VB_Name = "MDIForm1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private m_Col As Collection

Private m_MDI As MDIConnector
Attribute m_MDI.VB_VarHelpID = -1
Private WithEvents m_Menu As EnhancedMenu
Attribute m_Menu.VB_VarHelpID = -1

Public Property Get Connector() As MDIConnector
    Set Connector = m_MDI
End Property

Public Property Get MainMenu() As EnhancedMenu
    Set MainMenu = m_Menu
End Property

Private Sub m_Menu_ItemSelect(MenuObject As ExtendedMenu.MenuItem)

    If MenuObject.Key = "FORM1" Then
        Form1.Show
    
    ElseIf MenuObject.Key = "FORM2" Then
        AddWindow
        
    End If

End Sub

Public Sub AddWindow()
    Dim v_Frm As Form2

        Set v_Frm = New Form2
        
        v_Frm.Caption = v_Frm.Caption + " - #" + Format(m_Col.Count + 1)
        v_Frm.Show
        m_Col.Add v_Frm
        
End Sub

Private Sub MDIForm_Load()
    Set m_Col = New Collection
    
    Set m_Menu = New EnhancedMenu
    Set m_MDI = New MDIConnector
    
    m_MDI.SetWindowHandle hWnd
    
    With m_Menu
    
        .Add "&File", , "FILE"
        .Item("FILE").Submenu.Add "Show LastDraw of &File", , "LDRAW"
        .Item("FILE").Submenu.Add "-"
        .Item("FILE").Submenu.Add "Show Form #&1", , "FORM1"
        .Item("FILE").Submenu.Add "Show Form #&2", , "FORM2"
        .Item("FILE").Submenu.Item("FORM1").Default = True
        
    End With
        
    m_MDI.Connect m_Menu
        
End Sub

Private Sub MDIForm_Unload(Cancel As Integer)
    Dim v_Obj As Object
    
    For Each v_Obj In m_Col
        Unload v_Obj
    Next v_Obj
    
    m_MDI.Disconnect
    m_Menu.Destroy
    
    Set m_Menu = Nothing
End Sub
